﻿/*
	This file is part of Warzone Stat Editor by crab
    Copyright © 2011, 2012 Vladimir Salnikov
 
	Warzone Stat Editor by crab is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Warzone Stat Editor by crab is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Warzone Stat Editor by crab; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace WZStats
{
    public class StatAnalys
    {
        private Stats stats;
        public StatAnalys(Stats openedstats)
        {
            stats = openedstats;
        }
        public DataTable ResearchPrereqTree(string item_code, string statfile = "")
        {
            DataTable res_dt = new DataTable();
            if(statfile == "")
                foreach (string sfile in stats.FileList.Keys)
                {
                    Stats.StatFile st = stats.FileList[sfile];
                    if(st.Loaded)
                        if (st.data.Columns.Contains("Code"))
                        {
                            DataRow[] r = st.data.Select("Code='" + item_code + "'");
                            if (r.Length > 0)
                            {
                                statfile = sfile;
                                break;
                            }
                        }
                }
            if (!stats.FileList.ContainsKey(statfile))
                return res_dt;
            if(!stats.FileList[statfile].Loaded)
                return res_dt;
            if (!stats.FileList.ContainsKey("research.txt"))
                return res_dt;
            if (!stats.FileList["research.txt"].Loaded)
                return res_dt;
            if (!stats.FileList.ContainsKey("prresearch.txt"))
                return res_dt;
            if(!stats.FileList["prresearch.txt"].Loaded)
                return res_dt;

            DataColumn SonCol = stats.FileList["prresearch.txt"].data.Columns[0];
            DataColumn ParentCol  = stats.FileList["prresearch.txt"].data.Columns[0];
            DataColumn ResCode = stats.FileList["research.txt"].data.Columns["Code"];
            DataRelation ParentSonRel = new DataRelation("ParentSonRel", ParentCol, SonCol);
            DataRelation PreResRel = new DataRelation("PreResRel", ResCode, SonCol);

            return res_dt;
        }
        public int SumResearchPoints(string item_code, string statfile = "")
        {
            GetRequiredResearch(item_code, statfile);
            DataTable res_data = stats.FileList["research.txt"].data;
            return 0;
        }
        //private List<int> GetParentResearch(DataTable PreResearch, string res_code)
        //{
        //    DataRow[] rows = PreResearch.Select("[" + PreResearch.Columns[0].ColumnName + "]" + "='" + res_code + "'");
        //    List<int> result = new List<int>();
        //    for (int i = 0; i < rows.Length; i++)
        //    {
        //        result.Add(rows[i].
        //    }
        //}
        public DataRow GetRequiredResearch(string item_code, string statfile)
        {
            return null;
        }
        //public DataRow
    }
}
